/*
 * interpol.h
 *
 *  Created on: 07.12.2008
 *      Author: wolfgang
 */

#include <iostream>
using namespace std;

template <class T>
long interpolSearch(const T& key, T* vp, int len) {
	int expect, begin = 0, end = len -1;
	double temp;

	if (end < 0 			// Vektor leer
		|| key > vp[end]	// oder key nicht im
		|| key < vp[begin] )// Vektorbereich
		return -1;

	while (begin <= end) {
		if ( key < vp[begin] || key > vp[end] ) // key nicht im Bereich
			return -1;
		temp = (double) (key - vp[begin])
		    / (vp[end] - vp[begin]);
		temp = temp * (end - begin) + 0.5;
		expect = begin + (int)temp;
		if( vp[expect] == key )
			return expect;
		if( vp[expect] > key)
			end = expect -1;
		else begin = expect + 1;
	}
	return -1;
}

template <class T>
void insertionSort( T* vp, int len) {
	T temp;
	for(int i=0; i<len; i++) {
		temp = vp[i];				// Element herausnehmen
		int j;						// Groessere Elemnte hochshiften
		for(j = i-1; j >= 0 && vp[j] > temp; j--)
			vp[j+1] = vp[j];
		vp[j+1] = temp;				// Einfuegen
	}
}

template <class T>
void display(T* vp, int len) {
	cout << "\n Der Vektor: " << endl;
	for(int i=0; i<len; i++) {
		cout << vp[i] << "   ";
		if ( (i+1)%10 == 0)
			cout << endl;
	}
	cout << endl; cin.get();
}

